package kaysaar.aotd_question_of_loyalty.data.scripts;

import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.campaign.TextPanelAPI;
import kaysaar.aotd_question_of_loyalty.data.models.BaseFactionCommisionData;
import kaysaar.aotd_question_of_loyalty.data.scripts.commision.AoTDCommissionDataManager;
import kaysaar.aotd_question_of_loyalty.data.intel.AoTDCommIntelPlugin;
import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.util.Misc;
import com.fs.starfarer.api.EveryFrameScript;

public class AoTDDealWithNex implements EveryFrameScript
{
    public boolean isDone() {
        return false;
    }
    
    public boolean runWhilePaused() {
        return false;
    }
    
    public void advance(final float amount) {
        if (Misc.getCommissionIntel() == null) {
            Global.getSector().removeTransientScriptsOfClass((Class)this.getClass());
        }
        else {
            final FactionAPI factionAPI = Misc.getCommissionFaction();
            Global.getSector().removeScript((EveryFrameScript)Misc.getCommissionIntel());
            Global.getSector().getListenerManager().removeListenerOfClass((Class)Misc.getCommissionIntel().getClass());
            Misc.getCommissionIntel().endImmediately();
            if (AoTDCommIntelPlugin.get() == null && factionAPI != null) {
                try {
                    BaseFactionCommisionData data = AoTDCommissionDataManager.getInstance().getCommisionData(factionAPI.getId());
                    if (data == null) {
                        data = BaseFactionCommisionData.getDefaultCommisionData(factionAPI.getId());
                    }
                    final AoTDCommIntelPlugin intel = data.getPlugin();
                    intel.initializeFully(data, (TextPanelAPI)null, false, data.getFirstDefRank(), data.getFirstOfficialRank());
                }
                catch (final Exception e) {
                    throw new RuntimeException(e);
                }
            }
            Global.getSector().removeTransientScriptsOfClass((Class)this.getClass());
        }
    }
}
